Attribute VB_Name = "intersection_boite_triangle"
'---------------------------------------------------------------------------
' Point en 3D
'---------------------------------------------------------------------------
Public Type Point3
    X As Double
    Y As Double
    Z As Double
End Type
'---------------------------------------------------------------------------
' Triangle en 3D
'---------------------------------------------------------------------------
Public Type Triangle3
   S(2) As Point3
End Type
'---------------------------------------------------------------------------
'Boite en 3D
'---------------------------------------------------------------------------
Public Type Box3
   Centre As Point3
   Axes(2) As Point3
   Longueurs(2) As Double
End Type

' transforme un vecteur en vecteur unitaire
Function VecteurUnitaire(P1 As Point3) As Point3
Dim Norm As Double
Norm = Sqr((P1.X) ^ 2 + (P1.Y) ^ 2 + (P1.Z) ^ 2)
If Norm = 0 Then
    Exit Function
End If
    
    VecteurUnitaire.X = P1.X / Norm
    VecteurUnitaire.Y = P1.Y / Norm
    VecteurUnitaire.Z = P1.Z / Norm

End Function
'Produit vectoriel
Function VecProd(P1 As Point3, P2 As Point3) As Point3
Dim P4 As Point3

 P4.X = (P1.Y * P2.Z) - (P1.Z * P2.Y)
 P4.Y = (P1.Z * P2.X) - (P1.X * P2.Z)
 P4.Z = (P1.X * P2.Y) - (P1.Y * P2.X)
 VecProd = P4
 
End Function

'Produit Scalaire
Function Dot(p As Point3, q As Point3) As Double
    Dot = p.X * q.X + p.Y * q.Y + p.Z * q.Z
End Function

' Soustraction de vecteur
Function VecSub(P1 As Point3, P2 As Point3) As Point3
 VecSub.X = P1.X - P2.X
 VecSub.Y = P1.Y - P2.Y
 VecSub.Z = P1.Z - P2.Z
End Function


'----------------------------------------------------------------------------
Sub ProjectionTriangle(rkD As Point3, akV As Triangle3, rfMin As Double, rfMax As Double)
Dim afDot(2) As Double


    afDot(0) = Dot(rkD, akV.S(0))
    afDot(1) = Dot(rkD, akV.S(1))
    afDot(2) = Dot(rkD, akV.S(2))


    rfMin = afDot(0)
    rfMax = rfMin

    If (afDot(1) < rfMin) Then
        rfMin = afDot(1)
    Else
        If (afDot(1) > rfMax) Then
            rfMax = afDot(1)
        End If
    End If

    If (afDot(2) < rfMin) Then
        rfMin = afDot(2)
    Else
        If (afDot(2) > rfMax) Then
            rfMax = afDot(2)
        End If
    End If

End Sub
'----------------------------------------------------------------------------
Sub ProjectionBoite(rkD As Point3, rbBox As Box3, rfMin As Double, rfMax As Double)
Dim fDdC As Double
Dim fR As Double
Dim cpBox As Box3

    cpBox = rbBox
    fDdC = Dot(rkD, cpBox.Centre)
    fR = cpBox.Longueurs(0) * Abs(Dot(rkD, cpBox.Axes(0))) + cpBox.Longueurs(1) * Abs(Dot(rkD, cpBox.Axes(1))) + cpBox.Longueurs(2) * Abs(Dot(rkD, cpBox.Axes(2)))
    rfMin = fDdC - fR
    rfMax = fDdC + fR
End Sub

'----------------------------------------------------------------------------
Function TestIntersectionTriangleBox(apkTri As Triangle3, rkBox As Box3) As Boolean
    Dim fMin0 As Double
    Dim fMax0 As Double
    Dim fMin1 As Double
    Dim fMax1 As Double
    Dim fDdC As Double
    
    Dim kD As Point3
    Dim akE(2) As Point3
    Dim i0 As Integer
    Dim i1 As Integer
    
    Dim cpBox As Box3

     cpBox = rkBox
     
    ' test la direction de la normale du triangle
    akE(0) = VecSub(apkTri.S(1), apkTri.S(0)) '
    akE(1) = VecSub(apkTri.S(2), apkTri.S(0))  '
    'Creation de la normale
    kD = VecProd(akE(0), akE(1)) '
    fMin0 = Dot(kD, apkTri.S(0)) '
    fMax0 = fMin0 '
    Call ProjectionBoite(kD, cpBox, fMin1, fMax1) '
    If (fMax1 < fMin0 Or fMax0 < fMin1) Then
        TestIntersectionTriangleBox = False
        Exit Function
    End If

    ' test la direction des faces de la boite
    For i = 0 To 2
        kD = cpBox.Axes(i) '
        Call ProjectionTriangle(kD, apkTri, fMin0, fMax0)
        fDdC = Dot(kD, cpBox.Centre) '
        fMin1 = fDdC - cpBox.Longueurs(i) '
        fMax1 = fDdC + cpBox.Longueurs(i) '
        If (fMax1 < fMin0 Or fMax0 < fMin1) Then
                TestIntersectionTriangleBox = False
                Exit Function
        End If
    Next i

    ' test la direction du triangle-boite limites du produit vectoriel
    akE(2) = VecSub(akE(1), akE(0))  '
    For i0 = 0 To 2
        For i1 = 0 To 2
            kD = VecProd(akE(i0), cpBox.Axes(i1)) '
            Call ProjectionTriangle(kD, apkTri, fMin0, fMax0)
            Call ProjectionBoite(kD, cpBox, fMin1, fMax1)
            If (fMax1 < fMin0 Or fMax0 < fMin1) Then
                TestIntersectionTriangleBox = False
                Exit Function
            End If
        Next i1
    Next i0
    TestIntersectionTriangleBox = True
    
End Function

